@echo off

rem projekt
set CHIP=16f887
set name=pokus
set volt=4.5

rem system
set compiler=..\..\Tools\PICC960\bin\picc.exe
set progpath=..\..\Tools\Pickit\
set programmer=..\..\Tools\Pickit\pk2cmd.exe

rem ===============================================
set CFLAGS=--chip=%CHIP% -P --opt=default,+asm,-speed,9 --warn=0 --double=24 -q -g --asmlist
set LFLAGS=--runtime=default,+clear,+init,-keep,+osccal,-download,-ramtest,-resetbits


setlocal ENABLEDELAYEDEXPANSION

if not exist %compiler% (
  echo Neviem najst kompilator "%compiler%"
  goto err
)

if not exist %programmer% (
  echo Neviem najst programator "%programmer%"
  goto err
)

rem skompilujeme .c subory
set objs=
for %%f in (*.c) do (
  %compiler% %cflags% -c %%f
  if errorlevel 1 (
    echo.
    echo Nepodarilo sa skompilovat "%%f"
    goto err
  )
  set objs=!objs! %%f
)

if "%objs%"=="" (
  echo Ziadne zdrojove subory neboli najdene
  goto err
)

rem zlinkujeme
%compiler% -o%name%.cof -m%name%.map %LFLAGS% %OBJS% %CFLAGS%
if errorlevel 1 (
  echo Nepodarilo sa zlinkovat
  goto err
)

rem napalime
copy %name%.hex %progpath%%name%.hex
pushd %progpath%
 
if "%volt%"=="" (
  %programmer% /PPIC%chip% /F%name%.hex /M /T
) else (
  %programmer% /PPIC%chip% /F%name%.hex /M /T /A%volt%
)

del %name%.hex
popd

if errorlevel 1 (
  echo Nepodarilo sa napalit
  goto err
)
     
:clean
rem clean
del *.obj *.p1 *.lst *.cof *.rlf *.sdb *.hxl *.sym *.map
goto :eof

:err
echo Failed.
rem clean
del *.obj *.p1 *.lst *.cof *.rlf *.sdb *.hxl *.sym *.map
goto :eof


# microchip pic in visual studio makefile
# 
# gabonator@inmail.sk
#
#
CHIP=16F887
COMPILER=C:\Programs\Devel\PICC\9.60\bin\picc.exe
CFLAGS=--chip=$(CHIP) -P --opt=default,+asm,-speed,9 --warn=0 --double=24 -q -g --asmlist $(FMTWARNING) $(FMTADVISORY) $(FMTERROR)
LFLAGS=--runtime=default,+clear,+init,-keep,+osccal,-download,-ramtest,-resetbits
FMTERROR="--errformat=%f(%l) : error [%n] %%s %l.%c" 
FMTADVISORY="--msgformat=Advisory[%n] %%s" 
FMTWARNING="--warnformat=%f(%l) : warning [%n] %%s %l.%c" 
NAME=pictest

OBJS=maly.c delay.c

.c.obj::
	$(COMPILER) $(CFLAGS) -c $<

all: 	test.hex

cleansub:
	del *.p1 *.lst *.cof *.sdb *.hxl *.sym *.map *.i
clean: 
	del *.obj *.p1 *.lst *.cof *.hex *.rlf *.sdb *.hxl *.sym

build: $(OBJS)
link:
	$(COMPILER) -otest.cof -mtest.map $(LFLAGS) $(OBJS) $(CFLAGS)

test.hex: build link

run:	program on

program:
	PK2CMD /PPIC16F648A /Ftest.hex /M
on:
	PK2CMD /PPIC16F648A /T /A5.0
off:
	PK2CMD /PPIC16F648A /W


