#include <pic.h>

__CONFIG(LVPDIS & BORDIS & UNPROTECT & MCLRDIS & PWRTEN & WDTDIS & INTIO);        

#include "delay.h"

volatile unsigned char rtc_clk = 0;
volatile unsigned char newsecond = 0;

void Timer4ms(void)
{
	RD6 = !RD6;
}

void Timer1s(void)
{
  newsecond = 1;
//	RD7 = !RD7;
}

void interrupt isr(void)
{
	// RTC/SOUND timer (4ms/intr)
	if ((TMR2IE)&&(TMR2IF)) 
	{
		// RTC
		Timer4ms();
		if(++rtc_clk == 250)
		{
			rtc_clk = 0;
			Timer1s();
		}
		TMR2IF=0;
	}

}

void TimerInit(void)
{
	// timer 2 (RTC)
	PIE1	= 0b00000011;	// TMR2 to PR2 match
	INTCON	= 0b01000000;	// peripheral int.
	T2CON	= 0b00000110;	// post =1, enable, pre = 16
	PR2	= 0b11111001;  		// 249+1

	ei();	// Global interrupts enabled
}

void main()
{
//	char i; // -128..127
//	unsigned char i; // 0..255
	int i; // -32768..32767


	TRISD0 = 0;
	TRISD7 = 0;
	TRISD6 = 0;


	TRISA1 = 1;
	// nastavenie multiplexora
	CHS3 = 0;
	CHS2 = 0;
	CHS1 = 0;
	CHS0 = 1;  
	// CHS3:0   0001 => AN1 (RA1)

	TimerInit();

	while (1) 
	{

		ADON = 1;
		GODONE = 1;
		while ( GODONE == 1 )
		{
		}

		i = ADRESH;

		if (ADRESH > 128)
			RD0 = 1;
		else 
			RD0 = 0;

		if (newsecond==1)
		{
			newsecond=0;
			RD7 = !RD7;
		}

	}
}
