
/* special function registers */

C       equ     0
Z       equ     2
PCL	equ	2

#ifdef	_PIC16
INDF	equ	0
FSR	equ	1
STATUS	equ	4
PCLATH	equ	3
TBLPTRL	equ	0Dh
TBLPTRH	equ	0Eh
WREG	equ	0Ah
BSR	equ	0Fh
PRODL	equ	18h
PRODH	equ	19h
#else
STATUS	equ	3
FSR	equ	4
INDF	equ	0
PCLATH	equ	0Ah
#endif

#ifdef	_PIC12
#define	return	retlw 0
#endif

; A macro which ensures that the memory bank in which the temp psect
; resides is selected.
; It swaps bank if there is no common area and there is more than
; one bank of memory available.

SELTEMP	macro

// The 17 series is special in that some chips have common memory, but not
// enough to fit all the temp psect.

#if defined _PIC16 && !defined _17C42
	movlr	0h
#endif

#if	(!_COMMON_) && _BANKBITS_

// _PIC12 do nothing

#ifdef	_PIC14
	bcf	STATUS,5
#if	_BANKBITS_ == 2
	bcf	STATUS,6
#endif
#endif	_PIC14

#endif	(!_COMMON_) && _BANKBITS_

	endm

; A macro to select bank 0

SELBANK0	macro

#if defined _PIC16 && !defined _17C42
	movlr	0h
#endif

#ifdef	_PIC14
	bcf	STATUS,5
#if	_BANKBITS_ == 2
	bcf	STATUS,6
#endif
#endif
	endm

