;	Byte division for PIC 16C5x

#ifdef	_PIC12
	psect	float_text1,class=ENTRY,delta=2,size=512
	psect	ftext0,local,class=ENTRY,delta=2,with=float_text1
#else
	psect	float_text1,class=CODE,delta=2
#endif

	global	lbdiv,lbmod,dobdiv
	global	lbdiv_t,lbmod_t

;	Unsigned division - called with the dividend in w and the
;	divisor in btemp+1. For Highend processors, dividend is in btemp

#include	"sfr.h"

lbdiv
lbmod
#ifndef _PIC16
	SELTEMP
	movwf	dend		;store dividend
#endif
lbdiv_t
lbmod_t
#ifdef	_PIC12
	clrf	FSR
#endif
	SELTEMP
	clrf	flags
dobdiv
	bcf	STATUS,C	;clear carry
	movlw	-3
	addwf	visor,w
	btfss	STATUS,C
	goto	special		;special handling for divisor 0 or 1
	clrf	cntr		;reset counter counter
	movlw	0F0h		;check for most sig nibble all zero
	andwf	visor,w
	btfss	STATUS,Z	;skip if zero
	goto	startloop
	movlw	4
	movwf	cntr		;init counter to 4
	swapf	visor		;swap nibbles in divisor
startloop
	clrf	quot		;initialize quotient
#ifndef	_PIC16
	bcf	STATUS,C	;clear carry
#endif
sloop
	incf	cntr
	rlf	visor		;shift divisor up
	btfss	STATUS,C	;skip if msb set
	goto	sloop		;otherwise loop
dloop
	rrf	visor		;shift divisor down
	movf	visor,w		;load divisor
	subwf	dend,w		;subtract from dividend
	btfsc	STATUS,C	;overflow if carry clear!
	movwf	dend		;store result
	rlf	quot		;shift quotient up - shifting in result bit
	decfsz	cntr		;decrement count
	goto	dloop		;loop if more

tstneg:
	btfss	flags,7		;check quotient sign bit
	goto	negrem
	comf	quot
	incf	quot		;negate
negrem
#if	defined(_PIC14) || defined(_PIC16)
	movf	quot,w
#endif
	btfss	flags,7		;check remainder sign bit
	return
	comf	dend
	incf	dend
	return
special:
	rrf	visor		;check for visor == 1
	btfsc	STATUS,C
	goto	isone
	rrf	visor
	btfss	STATUS,C	;skip if divide by 2
	clrf	dend		;division by zero -> 0
	bcf	STATUS,C
	rrf	dend		;divide by two
	btfss	STATUS,C
isone
	bcf	STATUS,C
	movf	dend,w		;copy dividend to quotient
	movwf	quot
	clrf	dend
	rlf	dend		;shift remainder into remainder
	goto	tstneg		;go fix up signs

        psect   temp,global,class=BANK0,space=1,ovrld
dend	ds	1	;dividend
visor	ds	1	;divisor
quot	ds	1	;quotient
cntr	ds	1	;counter
flags	ds	1	;sign bits


	end
