;	Copyright (C) 1997 HI-TECH Software 

#include	"double.h"

	global	storeback


;	unpack1 - unpacks the left operand. It is in btemp+0

flunpack1
	SELBANK0
	clrf	signs		;zero sign bits, may not be in common
	rlf	mant1+2,w	;get LS bit of exponent
	rlf	mant1+3,w	;rotate into the exponent
	movwf	exp1		;store exponent
#ifdef _PIC16
	iorlw	0		;test for zero
#else
	movf	exp1,w
#endif
	btfsc	STATUS,Z	;skip if non-zero
	goto	zerct		;all zero, go away
	rlf	signs		;put sign bit in LSB of signs
	clrf	mant1+3		;clear MS byte of mantissa
	bsf	mant1+2,7	;set hidden bit
	return

;	Utility routines
fpover
fpunder
zerct
	clrf	mant1+0
	clrf	mant1+1
	clrf	mant1+2
	clrf	mant1+3
	retlw	0
;	unpack2 - unpacks right operand

#ifdef	_PIC12
	psect	ftext1,class=ENTRY,local,delta=2,with=float_text0
#endif
; assume that flunpack1 has already been called and has selected temp psect
flunpack2
	bcf	signs,1		;zero sign bit
	rlf	mant2+2,w	;get LS bit of exponent
	rlf	mant2+3,w	;rotate into the exponent
	movwf	exp2		;store exponent
#ifdef _PIC16
	iorlw	0		;test for zero
#else
	movf	exp2,w
#endif
	btfsc	STATUS,Z	;skip if non-zero
	goto	zer2		;all zero, go away
	btfsc	STATUS,C	;test sign bit
	bsf	signs,1
	clrf	mant2+3		;clear MS byte of mantissa
	bsf	mant2+2,7	;set hidden bit
	return

zer2
	clrf	exp2
	clrf	mant2
	clrf	mant2+1
	clrf	mant2+2
	clrf	mant2+3
	return

;	pack1 - put operand 1 back into float format

pack1
	movf	exp1,w		;get exponent
#ifdef	_PIC16
	iorlw	0
#endif
	btfsc	STATUS,Z	;if exponent zero, then whole number is zero
	goto	zerct
	bcf	mant1+2,7	;reset hidden bit
	rrf	signs		;get sign bit into carry
	rrf	exp1,w		;rotate into exponent
	movwf	mant1+3		;store exponent
	btfsc	STATUS,C	;check LS bit
	bsf	mant1+2,7	;set LS bit of exponent
	goto	storeback

;	norm1 - normalize the unpacked value in 1 and repack it

#ifdef	_PIC12
	psect	ftext2,class=CODE,local,delta=2,with=float_text0
#endif
flnorm1
#ifdef	_PIC16
	movf	exp1,w		;check for zero exponent
	iorlw	0
#else
	movf	exp1		;check for zero exponent
#endif
	btfsc	STATUS,Z
	goto	zerores		;zero the mantissa if so
	movf	mant1+3,w		;get top byte
#ifdef	_PIC16
	iorlw	0
#endif
	btfsc	STATUS,Z
	goto	norup		;zero, so shift up if anything
nordn
	decf	mant1+3,w	;check for == 1
	btfsc	STATUS,Z
	incf	mant1+0		;add one for rounding
	btfsc	STATUS,Z
	incf	mant1+1		;add one for rounding
	btfsc	STATUS,Z
	incf	mant1+2		;add one for rounding
	btfsc	STATUS,Z
	incf	mant1+3		;add one for rounding
1:
	bcf	STATUS,C	;shift in a zero
	rrf	mant1+3		;rotate down one bit
	rrf	mant1+2		;rotate down one bit
	rrf	mant1+1		;rotate down one bit
	rrf	mant1+0		;rotate down one bit
	incf	exp1		;increment exponent
	goto	flnorm1

norup
	movf	mant1+0,w	;test for zero mantissa
	iorwf	mant1+1,w
	iorwf	mant1+2,w
	iorwf	mant1+3,w
	btfsc	STATUS,Z
	goto	zerores		;zero everything
norup1
	btfsc	mant1+2,7	;test top bit
	goto	pack1		;set, go pack it up
	decf	exp1		;decrement exponent
	btfsc	STATUS,Z
	goto	zerores		;zero everything
	bcf	STATUS,C
	rlf	mant1+0
	rlf	mant1+1
	rlf	mant1+2
	goto	norup1

zerores
	clrf	mant1+0
	clrf	mant1+1
	clrf	mant1+2
	clrf	mant1+3
	goto	storeback

	end
