#ifdef _PIC16
;		32-BIT FLOATING POINT MULTIPLY AND DIVIDE ROUTINES
;			To be used in conjunction with PIC C7.84
;			  Copy Right Mohammad Bilal Malik 1999

#include	"fastdbl.h"

	global fldiv,fldiv_x,storeback


;**********************************************************************************************
;       Floating Point Divide

;       Input:  32 bit floating point dividend in AEXP, AARGB0, AARGB1, AARGB2
;               32 bit floating point divisor in BEXP, BARGB0, BARGB1, BARGB2
;**********************************************************************************************


fldiv		clrf		FSR
fldiv_x		
		movlr		0			; Bank 0
		;bcf		STATUS,0????
		rlcf 		AARGB0 		; IEEE to PIC
		rlcf 		AEXP
		rrcf 		AARGB0
		
		rlcf 		BARGB0 		; IEEE to PIC
		rlcf 		BEXP
		rrcf 		BARGB0

		movpf		TBLPTRL, TL_BK		; Back up Table Pointers
		movpf		TBLPTRH, TH_BK		; Back up Table Pointers
		

FPD32           clrf            TEMPB3,W		; clear exponent modification
                cpfsgt          BEXP                    ; test for divide by zero
                goto            SETFDZ32

                cpfsgt          AEXP
                goto            RES032

D32BNE0         movfp           AARGB0,WREG
                xorwf           BARGB0,W
                movpf           WREG,SIGN               ; save sign in SIGN

                bsf             AARGB0,MSB              ; make argument MSB's explicit
                bsf             BARGB0,MSB

		movlw		HIGH (IBTBL128I)	; access table for F0
		movwf		TBLPTRH
		movfp		BARGB0,WREG
		andlw		0x7F
		addlw		LOW (IBTBL128I)
		movwf		TBLPTRL
		btfsc		STATUS,C
		incf		TBLPTRH
		tablrd		0,1,TEMPB0
		tlrd		1,TEMPB0
		tablrd		0,0,TEMPB1
		tlrd		1,AARGB4
		tlrd		0,AARGB5

		movfp		AARGB5,WREG		; calculate difference
		subwf		TEMPB1,W
		movwf		AARGB5
		movfp		AARGB4,WREG
		subwfb		TEMPB0,W
		movwf		AARGB4


		movfp		AARGB5,WREG
		movpf		WREG,TEMPB2	
		mulwf		BARGB2
		movpf		PRODH,TBLPTRH
		
		movfp		AARGB4,WREG
		mulwf		BARGB1
		movpf		PRODH,AARGB4
		movpf		PRODL,AARGB5

		mulwf		BARGB2
		movpf		PRODL,WREG
		addwf		TBLPTRH
		movpf		PRODH,WREG
		addwfc		AARGB5
		clrf		WREG
		addwfc		AARGB4

		movfp		TEMPB2,WREG
		mulwf		BARGB1
		movpf		PRODL,WREG
		addwf		TBLPTRH
		movpf		PRODH,WREG
		addwfc		AARGB5
		clrf		WREG
		addwfc		AARGB4

		clrf		TEMPB2
		movfp		TBLPTRH,WREG
		subwf		TEMPB2
		movfp		AARGB5,WREG
		subwfb		TEMPB1
		movfp		AARGB4,WREG
		subwfb		TEMPB0		; F0

 
		movpf		AARGB0,AARGB5		; A0 = F0 * A	
		movpf		AARGB1,TBLPTRH	
		movpf		AARGB2,TBLPTRL	
		
		movfp		AARGB2,WREG
		mulwf		TEMPB2
		movpf		PRODH,AARGB4
		
		movfp		AARGB1,WREG
		mulwf		TEMPB1
		movpf		PRODH,AARGB2
		movpf		PRODL,AARGB3

		mulwf		TEMPB2
		movpf		PRODL,WREG
		addwf		AARGB4
		movpf		PRODH,WREG
		addwfc		AARGB3
		clrf		WREG
		addwfc		AARGB2

		movfp		TBLPTRL,WREG
		mulwf		TEMPB1
		movpf		PRODL,WREG
		addwf		AARGB4
		movpf		PRODH,WREG
		addwfc		AARGB3
		clrf		WREG
		addwfc		AARGB2
	
		movfp		AARGB0,WREG
		mulwf		TEMPB2
		movpf		PRODL,WREG
		addwf		AARGB3
		movpf		PRODH,WREG
		addwfc		AARGB2
		movfp		AARGB0,WREG
		mulwf		TEMPB1
		clrf		AARGB1,W
		addwfc		AARGB1
		movpf		PRODL,WREG
		addwf		AARGB2
		movpf		PRODH,WREG
		addwfc		AARGB1

		movfp		TBLPTRL,WREG
		mulwf		TEMPB0
		movpf		PRODL,WREG
		addwf		AARGB3
		movpf		PRODH,WREG
		addwfc		AARGB2
		clrf		AARGB0,W
		addwfc		AARGB1
		addwfc		AARGB0

		movfp		TBLPTRH,WREG
		mulwf		TEMPB0
		movpf		PRODL,WREG
		addwf		AARGB2
		movpf		PRODH,WREG
		addwfc		AARGB1
		clrf		WREG
		addwfc		AARGB0

		movfp		AARGB5,WREG
		mulwf		TEMPB0
		movpf		PRODL,WREG
		addwf		AARGB1
		movpf		PRODH,WREG
		addwfc		AARGB0
	
		btfsc		AARGB0,MSB
		goto		DAOK32
		rlcf		AARGB3
		rlcf		AARGB2
		rlcf		AARGB1
		rlcf		AARGB0
		decf		TEMPB3

DAOK32
		movfp		BARGB0,WREG
		movpf		WREG,AARGB5		; B0 = F0 * B	
		movfp		BARGB1,TBLPTRH	
		movfp		BARGB2,TBLPTRL	
		
		movfp		BARGB2,WREG
		mulwf		TEMPB2
		movpf		PRODH,AARGB4
		
		movfp		BARGB1,WREG
		mulwf		TEMPB1
		movpf		PRODH,BARGB2
		movpf		PRODL,BARGB3

		mulwf		TEMPB2
		movpf		PRODL,WREG
		addwf		AARGB4
		movpf		PRODH,WREG
		addwfc		BARGB3
		clrf		WREG
		addwfc		BARGB2

		movfp		TBLPTRL,WREG
		mulwf		TEMPB1
		movpf		PRODL,WREG
		addwf		AARGB4
		movpf		PRODH,WREG
		addwfc		BARGB3
		clrf		WREG
		addwfc		BARGB2
	
		movfp		BARGB0,WREG
		mulwf		TEMPB2
		movpf		PRODL,WREG
		addwf		BARGB3
		movpf		PRODH,WREG
		addwfC		BARGB2
		movfp		BARGB0,WREG
		mulwf		TEMPB1
		clrf		BARGB1,W
		addwfC		BARGB1
		movpf		PRODL,WREG
		addwf		BARGB2
		movpf		PRODH,WREG
		addwfC		BARGB1

		movfp		TBLPTRL,WREG
		mulwf		TEMPB0
		movpf		PRODL,WREG
		addwf		BARGB3
		movpf		PRODH,WREG
		addwfC		BARGB2
		clrf		BARGB0,W
		addwfc		BARGB1
		addwfc		BARGB0

		movfp		TBLPTRH,WREG
		mulwf		TEMPB0
		movpf		PRODL,WREG
		addwf		BARGB2
		movpf		PRODH,WREG
		addwfc		BARGB1
		clrf		WREG
		addwfc		BARGB0

		movfp		AARGB5,WREG
		mulwf		TEMPB0
		movpf		PRODL,WREG
		addwf		BARGB1
		movpf		PRODH,WREG
		addwfc		BARGB0
	
		btfss		BARGB0,MSB
		btfsc		BARGB0,MSB-1
		goto		DBOK32
		rlcf		AARGB4
		rlcf		BARGB3
		rlcf		BARGB2
		rlcf		BARGB1
		rlcf		BARGB0
		incf		TEMPB3

DBOK32
		comf		BARGB3
		comf		BARGB2
		comf		BARGB1		; F1 = 2 - B0
		comf		BARGB0
		incf		BARGB3
		clrf		WREG
		addwfc		BARGB2
		addwfc		BARGB1
		addwfc		BARGB0

		movpf		AARGB0,TEMPB0		; A1 = F1 * A0
		movpf		AARGB1,TEMPB1	
		movpf		AARGB2,TEMPB2	
		movfp		AARGB3,TBLPTRL	
		
		movfp		AARGB2,WREG
		mulwf		BARGB2
		movpf		PRODH,AARGB4
	
		movfp		AARGB1,WREG
		mulwf		BARGB3
		movpf		PRODH,WREG
		addwf		AARGB4
		movfp		AARGB1,WREG
		mulwf		BARGB2
		clrf		AARGB3,W
		addwfc		AARGB3
		movpf		PRODL,WREG
		addwf		AARGB4
		movpf		PRODH,WREG
		addwfc		AARGB3

		movfp		TBLPTRL,WREG
		mulwf		BARGB1
		movpf		PRODH,WREG
		addwf		AARGB4
		clrf		AARGB2,W
		addwfc		AARGB3
		addwfc		AARGB2

		movfp		TEMPB2,WREG
		mulwf		BARGB1
		movpf		PRODL,WREG
		addwf		AARGB4
		movpf		PRODH,WREG
		addwfc		AARGB3
		clrf		WREG
		addwfc		AARGB2

		movfp		TEMPB1,WREG
		mulwf		BARGB1
		movpf		PRODL,WREG
		addwf		AARGB3
		movpf		PRODH,WREG
		addwfc		AARGB2

		movfp		AARGB0,WREG
		mulwf		BARGB2
		movpf		PRODL,WREG
		addwf		AARGB3
		movpf		PRODH,WREG
		addwfc		AARGB2
		movfp		AARGB0,WREG
		mulwf		BARGB1
		clrf		AARGB1,W
		addwfc		AARGB1
		movpf		PRODL,WREG
		addwf		AARGB2
		movpf		PRODH,WREG
		addwfc		AARGB1

		movfp		TEMPB0,WREG
		mulwf		BARGB3
		movpf		PRODL,WREG
		addwf		AARGB4
		movpf		PRODH,WREG
		addwfc		AARGB3
		clrf		WREG
		addwfc		AARGB2
		addwfc		AARGB1

		movfp		TEMPB0,WREG
		mulwf		BARGB0
		movpf		PRODH,AARGB0
		movpf		PRODL,WREG
		addwf		AARGB1
		clrf		WREG
		addwfc		AARGB0

		movfp		TBLPTRL,WREG
		mulwf		BARGB0
		movpf		PRODL,WREG
		addwf		AARGB4
		movpf		PRODH,WREG
		addwfc		AARGB3
		clrf		WREG
		addwfc		AARGB2
		addwfc		AARGB1
		addwfc		AARGB0

		movfp		TEMPB2,WREG
		mulwf		BARGB0
		movpf		PRODL,WREG
		addwf		AARGB3
		movpf		PRODH,WREG
		addwfc		AARGB2
		clrf		WREG
		addwfc		AARGB1
		addwfc		AARGB0

		movfp		TEMPB1,WREG
		mulwf		BARGB0
		movpf		PRODL,WREG
		addwf		AARGB2
		movpf		PRODH,WREG
		addwfc		AARGB1
		clrf		WREG
		addwfc		AARGB0

		btfsc		AARGB0,MSB
		goto		DEXP32
		rlcf		AARGB3
		rlcf		AARGB2
		rlcf		AARGB1
		rlcf		AARGB0
		decf		TEMPB3

		btfsc		AARGB0,MSB
		goto		DEXP32
		rlcf		AARGB3
		rlcf		AARGB2
		rlcf		AARGB1
		rlcf		AARGB0
		decf		TEMPB3

DEXP32		movfp           BEXP,WREG               ; compute AEXP - BEXP
                subwf           EXP
		movlw		EXPBIAS+1		; add bias + 1 for scaling of F0
                btfss           STATUS,C
                goto            ALTB32
        
AGEB32		addwf           TEMPB3,W		; if AEXP > BEXP, test for overflow
                addwf           EXP

		movfp		TL_BK, TBLPTRL		; Restore Table Pointers
		movfp		TH_BK, TBLPTRH

                btfsc           STATUS,C
                goto            SETFOV32
                goto            DROUND32

ALTB32		addwf           TEMPB3,W		; if AEXP < BEXP, test for underflow
                addwf           EXP

		movfp		TL_BK, TBLPTRL		; Restore Table Pointers
		movfp		TH_BK, TBLPTRH

                btfss           STATUS,C
                goto            SETFUN32

DROUND32
		;btfsc           FPFLAGS,RND		; is rounding enabled? (on by default)
                btfss           AARGB3,MSB		; is NSB > 0x80?
                goto            DIV32OK
		bsf		STATUS,C			; set carry for rounding
		movlw		0x80
		cpfsgt		AARGB3			; if NSB = 0x80, select even
		rrcf		AARGB2,W		; using lsb in carry
                clrf            WREG
                addwfc          AARGB2
                addwfc          AARGB1
                addwfc          AARGB0

                btfss           STATUS,C		; test if rounding caused carryout
                goto            DIV32OK
                rrcf            AARGB0
                rrcf            AARGB1
                rrcf            AARGB2

		movfp		TL_BK, TBLPTRL		; Restore Table Pointers
		movfp		TH_BK, TBLPTRH

                infsnz          EXP			; test for overflow
                goto            SETFOV32

DIV32OK         btfss           SIGN,MSB
                bcf             AARGB0,MSB		; clear explicit MSB if positive


		movfp		TL_BK, TBLPTRL		; Restore Table Pointers
		movfp		TH_BK, TBLPTRH

		rlcf 		AARGB0		; PIC to IEEE
		rrcf 		AEXP
		rrcf 		AARGB0

                goto		storeback  



;----------------------------------------------------------------------------------------------

;	generation of F0 by interpolating between consecutive 16 bit approximations
;	to the reciprocal of BARG, with the top 7 explicit bits of BARG as a pointer
;	and the remaining 16 explicit bits as the argument to linear interpolation.

IBTBL128I
		DW	0xFFFF
		DW	0xFE04
		DW	0xFC10
		DW	0xFA23
		DW	0xF83E
		DW	0xF660
		DW	0xF48A
		DW	0xF2BA
		DW	0xF0F1
		DW	0xEF2F
		DW	0xED73
		DW	0xEBBE
		DW	0xEA0F
		DW	0xE866
		DW	0xE6C3
		DW	0xE526
		DW	0xE38E
		DW	0xE1FC
		DW	0xE070
		DW	0xDEE9
		DW	0xDD68
		DW	0xDBEB
		DW	0xDA74
		DW	0xD902
		DW	0xD794
		DW	0xD62C
		DW	0xD4C7
		DW	0xD368
		DW	0xD20D
		DW	0xD0B7
		DW	0xCF64
		DW	0xCE17
		DW	0xCCCD
		DW	0xCB87
		DW	0xCA46
		DW	0xC908
		DW	0xC7CE
		DW	0xC698
		DW	0xC566
		DW	0xC437
		DW	0xC30C
		DW	0xC1E5
		DW	0xC0C1
		DW	0xBFA0
		DW	0xBE83
		DW	0xBD69
		DW	0xBC52
		DW	0xBB3F
		DW	0xBA2F
		DW	0xB921
		DW	0xB817
		DW	0xB710
		DW	0xB60B
		DW	0xB50A
		DW	0xB40B
		DW	0xB30F
		DW	0xB216
		DW	0xB120
		DW	0xB02C
		DW	0xAF3B
		DW	0xAE4C
		DW	0xAD60
		DW	0xAC77
		DW	0xAB8F
		DW	0xAAAB
		DW	0xA9C8
		DW	0xA8E8
		DW	0xA80B
		DW	0xA72F
		DW	0xA656
		DW	0xA57F
		DW	0xA4AA
		DW	0xA3D7
		DW	0xA306
		DW	0xA238
		DW	0xA16B
		DW	0xA0A1
		DW	0x9FD8
		DW	0x9F11
		DW	0x9E4D
		DW	0x9D8A
		DW	0x9CC9
		DW	0x9C0A
		DW	0x9B4C
		DW	0x9A91
		DW	0x99D7
		DW	0x991F
		DW	0x9869
		DW	0x97B4
		DW	0x9701
		DW	0x9650
		DW	0x95A0
		DW	0x94F2
		DW	0x9446
		DW	0x939B
		DW	0x92F1
		DW	0x9249
		DW	0x91A3
		DW	0x90FE
		DW	0x905A
		DW	0x8FB8
		DW	0x8F17
		DW	0x8E78
		DW	0x8DDA
		DW	0x8D3E
		DW	0x8CA3
		DW	0x8C09
		DW	0x8B70
		DW	0x8AD9
		DW	0x8A43
		DW	0x89AE
		DW	0x891B
		DW	0x8889
		DW	0x87F8
		DW	0x8768
		DW	0x86D9
		DW	0x864C
		DW	0x85BF
		DW	0x8534
		DW	0x84AA
		DW	0x8421
		DW	0x8399
		DW	0x8312
		DW	0x828D
		DW	0x8208
		DW	0x8185
		DW	0x8102
		DW	0x8081
		DW	0x8001

#endif

