#ifdef _PIC16
;		32-BIT FLOATING POINT MULTIPLY AND DIVIDE ROUTINES
;			To be used in conjunction with PIC C7.84
;			  Copy Right Mohammad Bilal Malik 1999

#include	"fastdbl.h"

	global flmul,flmul_x,storeback


;**********************************************************************************************
;	Floating Point Multiply

;       Input:  32 bit floating point number in AEXP, AARGB0, AARGB1, AARGB2
;               32 bit floating point number in BEXP, BARGB0, BARGB1, BARGB2
;**********************************************************************************************

flmul
		clrf		FSR
flmul_x
		movlr		0		;select bank 0
		bcf		STATUS,0
		rlcf 		AARGB0		;convert from IEEE format to PIC
		rlcf 		AEXP
		rrcf 		AARGB0
		
		rlcf 		BARGB0
		rlcf 		BEXP
		rrcf 		BARGB0
		

FPM32           clrf            AARGB3,w	;test for zero arguments
                cpfseq          BEXP
                cpfsgt          AEXP
                goto            RES032

M32BNE0         movfp           AARGB0,WREG
                xorwf           BARGB0,w
                movpf           WREG,SIGN	;save sign in SIGN

                movfp           BEXP,WREG
                addwf           EXP
                movlw           EXPBIAS-1
                btfss           STATUS,C
                goto            MTUN32
        
                subwf           EXP		;remove bias and overflow test
                btfsc           STATUS,C
                goto            SETFOV32
                goto            MOK32

MTUN32          subwf           EXP		;remove bias and underflow test
                btfss           STATUS,C
                goto            SETFUN32

MOK32           bsf             AARGB0,MSB	;make argument MSB's explicit
                bsf             BARGB0,MSB

		movpf		AARGB0,TEMPB0	;multiply mantissas	
		movpf		AARGB1,TEMPB1	
		movpf		AARGB2,TEMPB2	

		movfp		AARGB2,WREG
		mulwf		BARGB2
		movpf		PRODH,AARGB4
		
		movfp		AARGB1,WREG
		mulwf		BARGB1
		movpf		PRODH,AARGB2
		movpf		PRODL,AARGB3

		mulwf		BARGB2
		movpf		PRODL,WREG
		addwf		AARGB4
		movpf		PRODH,WREG
		addwfc		AARGB3
		clrf		WREG
		addwfc		AARGB2

		movfp		TEMPB2,WREG
		mulwf		BARGB1
		movpf		PRODL,WREG
		addwf		AARGB4
		movpf		PRODH,WREG
		addwfc		AARGB3
		clrf		WREG
		addwfc		AARGB2

		movfp		AARGB0,WREG
		mulwf		BARGB2
		movpf		PRODL,WREG
		addwf		AARGB3
		movpf		PRODH,WREG
		addwfc		AARGB2
		movfp		AARGB0,WREG
		mulwf		BARGB1
		clrf		AARGB1,W
		addwfc		AARGB1
		movpf		PRODL,WREG
		addwf		AARGB2
		movpf		PRODH,WREG
		addwfc		AARGB1

		movfp		TEMPB2,WREG
		mulwf		BARGB0
		movpf		PRODL,WREG
		addwf		AARGB3
		movpf		PRODH,WREG
		addwfc		AARGB2
		clrf		AARGB0,W
		addwfc		AARGB1
		addwfc		AARGB0

		movfp		TEMPB1,WREG
		mulwf		BARGB0
		movpf		PRODL,WREG
		addwf		AARGB2
		movpf		PRODH,WREG
		addwfc		AARGB1
		clrf		WREG
		addwfc		AARGB0

		movfp		TEMPB0,WREG
		mulwf		BARGB0
		movpf		PRODL,WREG
		addwf		AARGB1
		movpf		PRODH,WREG
		addwfc		AARGB0

		btfsc		AARGB0,MSB	;check for postnormalization
		goto		MROUND32
		rlcf		AARGB3
		rlcf		AARGB2
		rlcf		AARGB1
		rlcf		AARGB0
		decf		EXP
		btfsc		STATUS,Z
		goto		SETFUN32

MROUND32
		;btfsc           FPFLAGS,RND	;is rounding enabled?
                btfss           AARGB3,MSB	;is NSB > 0x80?
                goto            MUL32OK
		bsf		STATUS,C	;set carry for rounding
		movlw		0x80
		cpfsgt		AARGB3		;if NSB = 0x80, select even
		rrcf		AARGB2,W	;using lsb in carry
                clrf            WREG
                addwfc          AARGB2
                addwfc          AARGB1
                addwfc          AARGB0

                btfss           STATUS,C	;has rounding caused carryout?
                goto            MUL32OK
                rrcf            AARGB0		;if so, right shift
                rrcf            AARGB1
                rrcf            AARGB2
                infsnz          EXP		;test for floating point overflow
                goto            SETFOV32

MUL32OK         btfss           SIGN,MSB
                bcf             AARGB0,MSB	;clear explicit MSB if positive

		rlcf 		AARGB0		;convert from PIC to IEEE format
		rrcf 		AEXP
		rrcf 		AARGB0

                goto		storeback  


#endif

