;	Copyright (C) 1997 HI-TECH Software 

;	Single Precision IEEE Floating point arithmetic routines for PIC
;	Division done here


#include	"double.h"

	global	fldiv,fldiv_x

;	Floating divide: divide the number in mant1 by mant2

	global	flunpack1,flunpack2
	FNCALL	fldiv,flunpack1
	FNCALL	fldiv,flunpack2
	FNCALL	fldiv_x,flunpack1
	FNCALL	fldiv_x,flunpack2

fldiv
	clrf	FSR
fldiv_x
	call	flunpack1
	call	flunpack2

divide
	clrf	prod
	clrf	prod+1
	clrf	prod+2
	clrf	prod+3
#ifdef	_PIC16
	movf	exp1,w		;check for zero dividend
	iorlw	0
#else
	movf	exp1,f		;check for zero dividend
#endif
	btfsc	STATUS,Z	;if zero, we are finished
	return
	movf	exp2,w		;check for zero divisor
#ifdef	_PIC16
	iorlw	0
#endif
	btfsc	STATUS,Z
	return

	subwf	exp1,w		;compute new exponent
#ifdef	_PIC12
	movwf	exp1
	movlw	127-8
	addwf	exp1
#else
	addlw	127-8		;unbias
	movwf	exp1		;store back
#endif
	rrf	signs,w		;get sign of RHS in bit 0
	xorwf	signs		;xor with LHS sign

	movlw	24+8		;initialize counter
	movwf	cntr
div1
	bcf	STATUS,C
	rlf	prod+0		;shift quotient up
	rlf	prod+1
	rlf	prod+2
	rlf	prod+3
#ifdef	_PIC16
	tstfsz	mant1+3
#else
	movf	mant1+3,w	;check MS byte
	btfss	STATUS,Z	;if non-zero, can definitely subtract
#endif
	goto	div4
	movf	mant2+2,w
	subwf	mant1+2,w	;check for subtract
	btfss	STATUS,Z	;if equal, check next byte
	goto	div3
	movf	mant2+1,w
	subwf	mant1+1,w	;check for subtract
	btfss	STATUS,Z	;if equal, check next byte
	goto	div3
	movf	mant2+0,w
	subwf	mant1+0,w	;check for subtract
div3
	btfss	STATUS,C	;carry is borrow complemented
	goto	div2		;skip the subtract
div4
        movf    mant2+0,w	;subtract mantissas
	subwf   mant1+0
	movf    mant2+1,w
	btfss   STATUS,C
	incfsz  mant2+1,w
	subwf   mant1+1
	movf    mant2+2,w
	btfss   STATUS,C
	incfsz  mant2+2,w
	subwf   mant1+2
	btfss   STATUS,C
	decf	mant1+3
	bsf	prod,0
div2
	bcf	STATUS,C
	rlf	mant1+0
	rlf	mant1+1
	rlf	mant1+2
	rlf	mant1+3
	decfsz	cntr
	goto	div1
	movf	prod,w
	movwf	mant1
	movf	prod+1,w
	movwf	mant1+1
	movf	prod+2,w
	movwf	mant1+2
	movf	prod+3,w
	movwf	mant1+3
	goto	flnorm1		;now normalize result

	end
