;	Long division for PIC 16C5x

#ifdef	_PIC12
	psect	float_text0,class=ENTRY,delta=2,size=512
	psect	ftext0,local,class=ENTRY,delta=2,with=float_text0
#else
	psect	float_text0,class=CODE,delta=2
#endif

	global	lldiv,llmod,lldiv_x,doldiv
	global	storeback

;	Unsigned division - called with the dividend in btemp+0-btemp+3 and the
;	divisor in btemp+4-btemp+7. The remainder is left in btemp+8

#include	"sfr.h"

lldiv
llmod
	clrf	FSR
lldiv_x
	SELBANK0
	clrf	flags		;clear sign bits
doldiv
	clrf	quot		;initialize quotient
	clrf	quot+1
	clrf	quot+2
	clrf	quot+3
	movf	visor+0,w	;check divisor for zero
	iorwf	visor+1,w
	iorwf	visor+2,w
	iorwf	visor+3,w
	btfsc	STATUS,Z	;all zero
	goto	retzero		;yep, division by zero -> 0
	movlw	0C0h		;mask flags
	andwf	cntr		;zero counter
	goto	slop1
retzero
	clrf	dend+0
	clrf	dend+1
	clrf	dend+2
	clrf	dend+3
	goto	storeback
sloop
	bcf	STATUS,C	;clear carry
	rlf	visor		;and rotate in
	rlf	visor+1
	rlf	visor+2
	rlf	visor+3
	incf	cntr
slop1
	btfss	visor+3,7	;skip if msb set
	goto	sloop		;otherwise loop
	incf	cntr		;add one to counter
dloop
	bcf	STATUS,C
	rlf	quot		;shift quotient up - carry still clear
	rlf	quot+1
	rlf	quot+2
	rlf	quot+3
	movf	visor+3,w	;load divisor
	subwf	dend+3,w	;subtract from dividend
	btfss	STATUS,Z	;result is non-zero?
	goto	tested		;we know the answer now
	movf	visor+2,w	;load divisor
	subwf	dend+2,w	;subtract from dividend
	btfss	STATUS,Z	;result is non-zero?
	goto	tested		;we know the answer now
	movf	visor+1,w	;load divisor
	subwf	dend+1,w	;subtract from dividend
	btfss	STATUS,Z	;result is non-zero?
	goto	tested		;we know the answer now
	movf	visor,w		;load divisor
	subwf	dend,w		;subtract from dividend
tested
	btfss	STATUS,C	;result is negative
	goto	next
	bsf	quot,0		;set lsb of quot
	movf	visor,w		;subtract divisor from dividend
	subwf	dend
	movf	visor+1,w
	btfss	STATUS,C
	incfsz	visor+1,w	;subtract borrow
	subwf	dend+1		;subtract high byte
	movf	visor+2,w
	btfss	STATUS,C
	incfsz	visor+2,w	;subtract borrow
	subwf	dend+2		;subtract high byte
	movf	visor+3,w
	btfss	STATUS,C
	incfsz	visor+3,w	;subtract borrow
	subwf	dend+3		;subtract high byte
next
	bcf	STATUS,C
	rrf	visor+3		;shift visor down
	rrf	visor+2
	rrf	visor+1
	rrf	visor
	decf	cntr
	movf	cntr,w		;get counter
	andlw	3Fh		;mask out counter bits
	btfss	STATUS,Z	;skip if zero
	goto	dloop		;loop if more

	; check signs and negate results if necessary
	btfss	flags,6		;check remainder sign bit
	goto	negquot
	bcf	STATUS,C
	movlw	0FFh
	addwf	dend
	comf	dend
	btfss	STATUS,C
	addwf	dend+1
	comf	dend+1
	btfss	STATUS,C
	addwf	dend+2
	comf	dend+2
	btfss	STATUS,C
	addwf	dend+3
	comf	dend+3
negquot
	movf	dend+0,w	;copy remainder
	movwf	visor+0
	movf	dend+1,w
	movwf	visor+1
	movf	dend+2,w
	movwf	visor+2
	movf	dend+3,w
	movwf	visor+3
	movf	quot+0,w	;copy quotient
	movwf	dend+0
	movf	quot+1,w
	movwf	dend+1
	movf	quot+2,w
	movwf	dend+2
	movf	quot+3,w
	movwf	dend+3
	btfss	flags,7		;check quotient sign bit
	goto	storeback
	bcf	STATUS,C
	movlw	0FFh
	addwf	dend
	comf	dend
	btfss	STATUS,C
	addwf	dend+1
	comf	dend+1
	btfss	STATUS,C
	addwf	dend+2
	comf	dend+2
	btfss	STATUS,C
	addwf	dend+3
	comf	dend+3
	goto	storeback

        psect   temp,global,class=BANK0,space=1,ovrld
dend	ds	4	;dividend
visor	ds	4	;divisor
quot	ds	4	;quotient

        psect   xtemp,ovrld,class=BANK0,space=1
cntr			;counter - same byte as flags 
flags	ds	1	;sign bits

	global	used_btemp0
	global	used_btemp1
	global	used_btemp2
	global	used_btemp3
	global	used_btemp4
	global	used_btemp5
	global	used_btemp6
	global	used_btemp7
	global	used_btemp8
	global	used_btemp9
	global	used_btemp10
	global	used_btemp11
	global	used_btemp12

	end
