;	Word division for PIC

#ifdef	_PIC12
	psect	float_text1,class=ENTRY,delta=2
	psect	ftext0,class=ENTRY,local,delta=2,with=float_text1
#else
	psect	float_text1,class=CODE,delta=2
#endif

	global	lwdiv,lwmod,dowdiv

;	Unsigned division - called with the dividend in btemp/btemp+1 and the
;	divisor in btemp+2/btemp+3

#include	"sfr.h"



lwdiv
lwmod
	SELTEMP
	clrf	flags		;clear sign bits
dowdiv
	clrf	quot		;initialize quotient
	clrf	quot+1
	movf	visor,w		;check divisor for zero
	iorwf	visor+1,w
	btfss	STATUS,Z
	goto	begin
	clrf	dend
	clrf	dend+1
	retlw	0
begin
	movlw	1Fh		;initialize counter
	iorwf	cntr
	bcf	STATUS,C	;clear carry
sloop
	incf	cntr
	rlf	visor		;rotate divisor up
	rlf	visor+1
slop1
	btfss	STATUS,C	;skip if msb set
	goto	sloop		;otherwise loop
dloop
	rrf	visor+1		;shift visor down
	rrf	visor
#ifdef	_PIC16
	movf	visor,w		;divisor low byte
	subwf	dend,w
	movf	visor+1,w
	subwfb	dend+1,w
#else
	movf	visor+1,w	;load divisor
	subwf	dend+1,w	;subtract from dividend
	btfss	STATUS,Z	;if equal, try low order byte
	goto	tested		;we know the answer now
	movf	visor,w		;load divisor
	subwf	dend,w		;subtract from dividend
#endif
tested
	btfss	STATUS,C	;result is negative if carry clear
	goto	next		;jump down to shift in a zero bit
#ifdef	_PIC16
	movwf	dend+1		;already have high byte of result
	movf	visor,w		;calculate low byte
	subwf	dend
	bsf	STATUS,C	;set carry ready for shift
#else
	movf	visor,w		;subtract divisor from dividend
	subwf	dend
	movf	visor+1,w
	btfss	STATUS,C
	incf	visor+1,w
	subwf	dend+1		;subtract high byte - carry will be SET
#endif
next
	rlf	quot		;shift quotient up - shifting in result bit
	rlf	quot+1		;carry is guaranteed clear after this
	decfsz	cntr		;decrement, will never skip (17Cxx does not set C)
	btfsc	cntr,5		;if count decremented below 20h, skip
	goto	dloop		;loop if more

	; check signs and negate results if necessary
	btfss	flags,7		;check quotient sign bit
	goto	negrem
	comf	quot
	incf	quot
	btfsc	STATUS,Z
	decf	quot+1
	comf	quot+1
negrem
	movf	quot,w
	movwf	visor		;copy quotient
	movf	quot+1,w
	movwf	visor+1
	btfss	flags,6		;check remainder sign bit
	retlw	0
	comf	dend
	incf	dend
	btfsc	STATUS,Z
	decf	dend+1
	comf	dend+1		;complete negation
	retlw	0

        psect   temp,global,class=BANK0,space=1,ovrld

dend	ds	2	;dividend
visor	ds	2	;divisor
quot	ds	2	;quotient
cntr	ds	1	;counter
flags	equ	cntr	;sign bits

	global	used_btemp0
	global	used_btemp1
	global	used_btemp2
	global	used_btemp3
	global	used_btemp4
	global	used_btemp5
	global	used_btemp6

	end
